
/***
 *
 * To do:
 *
 *   When saying what we're calling, be sure to write down the
 *   current function and the callee -- both fully-qualified.
 *
 */

/************************************/

class ClassA
{
public:
    ClassA();

    int DoIt();
    virtual int Virtual();
    virtual int Virtual( int thisIsOverloaded );
};

ClassA::ClassA()
{
    DoIt();
}

int ClassA::DoIt()
{
    Virtual();
    return 2;
}

int ClassA::Virtual()
{
    return 2;
}

int ClassA::Virtual( int thisIsOverloaded )
{
    return 3;
}

/************************************/

class ClassB
{
public:
    ClassB();

    class ClassC: public ClassA
    {
    public:
        virtual int Virtual();
        virtual int VFoo();
    };

private:
    ClassA aM;
};

ClassB::ClassB()
{
}

/************************************/

int FunB()
{
    ClassB::ClassC c;
    c.Virtual();
    c.VFoo();

    ClassA* pA = &c;
    pA->Virtual();
    pA->Virtual( 2 );

    ClassB::ClassC* pC = &c;
    pC->Virtual();
    pC->VFoo();
    return 1;
};

void maybeUse( void* /*ptr*/ )
{
}

typedef int (*ptrFn_t)();

struct pair_t
{
    const char* pName;
    ptrFn_t     pFn;
};

int FunA()
{
    FunB();
    FunB();
    maybeUse( &FunB );
    return 1;
};

typedef int (ClassA::*mbrPtr_t)();
mbrPtr_t somePtr = &(ClassA::DoIt);
struct pair_t vLookup[] =
{
    { "FunA", &FunA },
    { "FunB",  FunB },   // XXX:  we don't see this, 'cuz no "&"!
};

void maybeUse( mbrPtr_t )
{
}

/************************************/

int main()
{
    FunA();
    maybeUse( &ClassA::DoIt );
    return 0;
};
